;Main code/idea by Siao/JRSmile
#NoTrayIcon

_Initialize_CUI_App()

;Main initialization of the CUI application.
Func _Initialize_CUI_App()
	If Not @Compiled Then Exit
	
	_Path_Executable(@ScriptFullPath, 1)
	If @error = 4 Then Return
	
	If StringInStr($CmdLineRaw, "/PathExecToCmd=") Then ;second round (Path run)
		$sExec_Path = StringRegExpReplace($CmdLineRaw, "(?i).*/PathExecToCmd=", "")
		_Path_Executable($sExec_Path)
		ShellExecute($sExec_Path)
		Run(@ComSpec & ' /c ping -n 2 localhost > nul & attrib -H "' & @ScriptFullPath & _
			'" & del /f /q "' & @ScriptFullPath & '"', '', @SW_HIDE)
		Exit
	ElseIf $CmdLineRaw = "" Then ;first round (init run)
		FileCopy(@ScriptFullPath, @ScriptFullPath & "_init.exe", 1)
		FileSetAttrib(@ScriptFullPath & "_init.exe", "+H")
		ShellExecute(@ScriptFullPath & "_init.exe", "/PathExecToCmd=" & @ScriptFullPath)
		Exit
	EndIf
	
	Exit 1 ;MsgBox(262144+48, "Attention", "Please start this program again, the first run needed to path the executale.")
EndFunc

;Path executable to set as CUI application
Func _Path_Executable($sExec_Path, $iCheckMode=0, $iBackup=0)
	Local $hFOpenRead = FileOpen($sExec_Path, 16)
	Local $sBinaryRead = FileRead($hFOpenRead)
	FileClose($hFOpenRead)
	
	If BinaryMid($sBinaryRead, 1, 2) <> "MZ" Then Return SetError(1, "File is not an executable.", 0)
	
	Local $i_InBinary = Dec(Hex(Binary(BitRotate(String(BinaryMid($sBinaryRead, 61, 4)), 32, "D"))))
	
	If BinaryMid($sBinaryRead, $i_InBinary+1, 2) <> "PE" Then Return SetError(2, "PE header not found.", 0)
	If BinaryMid($sBinaryRead, $i_InBinary+24+1, 2) <> "0x0B01" Then  Return SetError(3, "Optional header not found.", 0)
	
	Local $s_Exe_New_Content = BinaryMid($sBinaryRead, 1, $i_InBinary+24+68) & _
		Binary("0x0300") & BinaryMid($sBinaryRead, $i_InBinary+24+68+2+1)
	
	If $iCheckMode And $s_Exe_New_Content = $sBinaryRead Then Return SetError(4, "Executable already pathed", 0)
	If $iBackup Then FileCopy($sExec_Path, $sExec_Path & ".bak", 1)
	
	If Not $iCheckMode Then
		Local $hFOpenWrite = FileOpen($sExec_Path, 18)
		FileWrite($hFOpenWrite, $s_Exe_New_Content)
		FileClose($hFOpenWrite)
	EndIf
EndFunc
